<?xml version="1.0"?>

<!-- 
/*
** Module   : java_templates.tpl
** Abstract : Java AST templates
**
** Copyright (c) 2004-2014, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** _#_ _I_ __Date__ __JPRM__ ___________________________ Description____________________________
** 001 GES 20050721   @21760 Good working version which provides many
**                           templates for processing variable references,
**                           variable definitions, method calls,
**                           loops/conditional logic and even a fairly
**                           complex main method.
** 002 GES 20050728   @21905 Added a template for the creation of
**                           initialized constants.
** 003 GES 20050731   @21935 Added templates for handling the shared var
**                           mgr, including accessors and a special
**                           try/finally block to enable proper scope
**                           handling.
** 004 GES 20050815   @22184 Made exception processing more generic,
**                           added major new control flow templates to
**                           support block properties, conditions and
**                           transactions.
** 005 GES 20050824   @22232 Added a template for array subscripts.
** 006 GES 20050825   @22241 Added a template for registration of cleanup
**                           processing.
** 007 GES 20051005   @22995 Added templates for buffer definitions.
** 008 GES 20051101   @23195 Added templates for frame/UI processing.
** 009 GES 20051107   @23296 Added template for assigning from a copy.
** 010 GES 20051115   @23360 Added template for runnable inner classes
**                           (used for triggers et al).
** 011 GES 20051117   @23365 Added editing_block template.
** 012 SIY 20051101   @23364 Added templates for frame classes generator.
** 013 GES 20051118   @23410 Added validating inner class.
** 014 SIY 20051119   @23415 Added more templates for frame_generator.
** 015 GES 20051124   @23455 Added another var def with initializer.
** 016 ECF 20051129   @23577 Added templates to invoke the assign method
**                           in various ways. Used for define/open query
**                           support using query wrappers.
** 017 GES 20051208   @23676 Added editing_block_go_on template.
** 018 SIY 20060110   @23852 Added "extends" to interface definition,
**                           added template for setUp() method.
** 019 SIY 20060112   @23861 Added class name cast in the set_widget_value 
**                           template.
** 020 ECF 20060109   @23878 Added new variants of variable definitions.
**                           Also added accumulate-specific templates.
** 021 ECF 20060118   @24001 Added templates related to presort queries
**                           and accumulators.
** 022 GES 20060131   @24166 Added pkgname annotation to top level class
**                           def templates.
** 023 GES 20060202   @24230 Added new flag to templates with pushScope().
** 024 GES 20060203   @24243 Changed TransactionManager method name
**                           makeBackup() to blockSetup().
** 025 GES 20060206   @24289 Added the named_array template.
** 026 ECF 20060205   @24306 Added temp-table support. New templates to
**                           create a temp table buffer and to associate
**                           temp tables with one another.
** 027 GES 20060207   @24349 Modified register_finish to add options.
** 028 SIY 20060206   @24368 Templates for VIEW-AS phrase handling.
** 029 ECF 20060219   @24699 Support client where clause processing. New
**                           templates to assist with WhereExpression
**                           instance variable definition.
** 030 GES 20060228   @24779 Added prompt-for support to editing blocks.
** 031 ECF 20060228   @24827 Removed throws statements from Validatable
**                           method signatures. These are superfluous,
**                           since the exception is a runtime exception
**                           which is only thrown incidentally.
** 032 GES 20060301   @24837 Template for transaction mgr support in all 
**                           functions. It has no retry support, end and
**                           error support is hard coded to leave and 
**                           there is a default return unknown value at
**                           the end. This all is to match the Progress
**                           behavior...
** 033 GES 20060303   @24875 Updates for subscripting.
** 034 SIY 20060315   @25147 Changed add_widget template and added 
**                           add_header_widget.
** 035 GES 20060318   @25104 Fixed loop increment helper and added a new
**                           option.
** 036 ECF 20060321   @25161 Added variable_assign_op template. Used to
**                           re-assign a previously declared Java variable
**                           (using the assignment operator).
** 037 GES 20060329   @25250 Added a simple assignment template.
** 038 GES 20060405   @25369 Added a template for casting a method call 
**                           return value.
** 039 NVS 20060406   @25405 Added a template for member variable assign-
**                           ment with an inner static method call.
** 040 ECF 20060419   @25615 Added peernode annotation to add_accumulator.
**                           Needed for secondary method variant.
** 041 ECF 20060422   @25656 Added set_iteration_type. Used for presort
**                           queries.
** 042 ECF 20060423   @25662 Added add_where_expression. Used for presort
**                           and preselect queries.
** 043 GES 20060426   @25721 Added a template for array variable 
**                           assignment.
** 044 ECF 20060502   @25937 Added variable_assign_op_default template.
**                           Issues an assignment operation with a default
**                           constructor as the rvalue.
** 045 GES 20060510   @26061 Editing blocks must not block on user input
**                           unless requested. Removed waitForNextKey().
** 046 GES 20060522   @26414 Certain inner classes have local data that
**                           must be made final to allow it to be accessed
**                           from within nested inner classes.
** 047 SIY 20060524   @26461 Added template for initializing widget with
**                           unknown value.
** 048 ECF 20060524   @26544 Made queries and BY expression Resolvable
**                           instances final. Added 'final' annotation
**                           (always true) to variable_def_unfin_ctor
**                           template.
** 049 ECF 20060531   @26845 Added query_off_end_catch template. Creates
**                           a catch block for QueryOffEndException.
** 050 GES 20060804   @28433 Honor new iterate() processing which only
**                           happens at the top of the block body.
** 051 ECF 20060913   @29598 Added template for defining a buffer for a
**                           temp-table.
** 052 ECF 20060926   @29936 Added variable_assign_unfin_ctor_op template.
**                           Assigns an unfinished constructor to an
**                           existing variable reference (using assignment
**                           operator, not assign() method).
** 053 GES 20061002   @30066 Added if_not_true_then_break template.
** 054 SIY 20061006   @30206 Changed signature of addWidget method.
** 055 GES 20061010   @30260 Modified construct_frame to support shared
**                           frames.
** 056 GES 20061120   @31308 Made anon_expr more generic by making the
**                           method name replaceable.
** 057 ECF 20061212   @31670 Added construct_temp_master_buffer_no_undo.
**                           This variant adds support for NO-UNDO on
**                           temp/work-table definitions.
** 058 SIY 20061225   @31746 Renamed setUp() to setup().
** 059 ECF 20070329   @32650 Added var_def_shared_tt. Defines a variable
**                           as a temp table record buffer proxy against a
**                           previously established temp table definition
**                           and backing temp table instance.
** 060 GES 20071218   @36438 Added a Throwable catch block to all of the
**                           transaction manager block templates as the
**                           last catch block.
** 061 CA  20080207   @37021 editing_block templates must emit its type to
**                           the TransactionManager.pushScope(...) call.
** 062 CA  20080220   @37126 Added templates to declare a final variable:
**                           variable_def_final and 
**                           variable_def_default_final.
** 063 GES 20080403   @37817 Minor signature changes to template parms.
** 064 CA  20080410   @37934 Added template accum_try_finally_block used 
**                           to enclose an IF statement with a try/finally 
**                           block, when the IF contains an ACCUM/DISPLAY 
**                           with aggregate phrase stmt.
** 065 GES 20080623   @38952 Added retry support to the function_block
**                           template. Removed dead code from the
**                           top_level_block. Pass explicit BlockType
**                           on every pushScope() now.
** 066 GES 20080627   @39011 Added honor_next and deregister templates.
** 067 GES 20080701   @39048 Added compact representation templates.
** 068 GES 20080814   @39430 Added deferred_break_continue.
** 069 GES 20080819   @39515 Added trigger_inner_class_def,
**                           variable_def_from_copy and
**                           inline_add_shared_var templates.
** 070 GES 20080826   @39586 Added enter_method_def template.
** 071 SIY 20080904   @39723 Added inner_frame_def template.
**                           Removed type cast from many templates.
** 072 GES 20080918   @39846 Added and modified templates for shared
**                           variable manager usage to handle new scope
**                           level support.
** 073 GES 20080926   @39972 Undo registration template updates.
** 074 GES 20081003   @40026 Added template to help avoid logical unwrap.
** 075 CA  20081009   @40073 Added templates to declare a final variable
**                           with parameters:variable_def_final_1_param  
**                           and variable_def_final_2_param.
** 076 GES 20081017   @40158 New template for trigger factory use.
** 077 GES 20081217   @40922 Removed an unused template.
** 078 GES 20090624   @42881 Added node to a template used for stream wrapper
**                           construction.
** 079 ECF 20090815   @43627 Modified dynamic_where_subscript template.
**                           Removed Mathops qualifier from static minus()
**                           method. Users must add a static import to files
**                           they emit.
** 080 GES 20101005          Added a basic javadoc template.
** 081 GES 20110201          Fixed array initialization templates.
** 082 CA  20111111          Added associate_temp_tables_append, which sets
**                           the "append" parameter to true, when the APPEND
**                           option is set at the buffer parameter definition.
** 083 ECF 20130119          Fix for Java 7. register_undo_global_var_args now
**                           emits TransactionManager.registerGlobal; removed
**                           first argument (BOOL_TRUE). Previous call to
**                           overloaded TransactionManager.register method was
**                           ambiguous under Java 7.
** 084 CA  20130126          Added register_in_handle_function.
** 085 CA  20130209          Added dynamic EXTENT and EXTENT parameter support.
** 086 SVL 20130213          Added database_trigger_inner_class_def.
** 087 GES 20130224          Added a buffer validation inner class template.
** 088 SVL 20130226          Added functions related to TABLE and TABLE-HANDLE parameters.
** 089 SVL 20130311          Added functions related to TABLE-HANDLE FOR parameters.
** 090 CA  20131018          Added template for a getQuery getter, used at runtime dynamic query 
**                           parsing.
** 091 SVL 20131115          Emit legacy buffer name in RecordBuffer/TemporaryBuffer.define
**                           statements.
** 092 CA  20131115          Added misc templates related to delayed initialization of static
**                           resources.
** 093 OM  20131128          Added trigger procedure template and trigger annotation template.
** 094 SVL 20140106          Changed signature of TemporaryBuffer.createDynamicTable.
** 095 OM  20140129          Added multiple section anchor nodes in trigger class definition.
** 096 HC  20140613          Improved extent parameter support - removed some of 
**                           the code being emitted and introduced multiple wrapper classes 
**                           depending on the parameter type and the l-value type (variable vs.
**                           field).
** 097 OM  20140808          Fixed removed hardcoded id from gen_getQuery template.
*/
 -->

<templates>

   <!-- class definition -->
   <ast-root name="class_def" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_CLASS" text="${classname}">
         <annotation datatype="java.lang.String" key="access" value="${access}" />
         <annotation datatype="java.lang.String" key="pkgname" value="${pkgname}" />
         <ast id="0" type="CS_CONSTANTS" text="" />
         <ast id="0" type="CS_STATIC_VARS" text="" />
         <ast id="0" type="CS_STATIC_INITS" text="" />
         <ast id="0" type="CS_INSTANCE_VARS" text="" />
         <ast id="0" type="CS_CONSTRUCTORS" text="" />
         <ast id="0" type="CS_STATIC_METHODS" text="" />
         <ast id="0" type="CS_INSTANCE_METHODS" text="" />
         <ast id="0" type="CS_INNER_CLASSES" text="" />
      </ast>
   </ast-root>

   <!-- definition for procedure/schema trigger classes -->
   <ast-root name="trigger_class_def" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_CLASS" text="${classname}">
         <annotation datatype="java.lang.String" key="extends"
                     value="DatabaseTrigger&lt;${bufclass}&gt;"/>
         <annotation datatype="java.lang.String" key="access" value="public" />
         <annotation datatype="java.lang.String" key="pkgname" value="${pkgname}" />
         <ast id="0" type="CS_CONSTANTS" text="" />
         <ast id="0" type="CS_STATIC_VARS" text="" />
         <ast id="0" type="CS_STATIC_INITS" text="" />
         <ast id="0" type="CS_INSTANCE_VARS" text="" />
         <ast id="0" type="CS_STATIC_METHODS" text="" />
         <ast id="0" type="CS_INSTANCE_METHODS" text="">
            <!-- here (just before the annotation) the initialization method will be inserted -->
            <ast id="0" text="Override" type="ANNOTATION" />
            <!-- here (just after the annotation) the db-trigger function will be appended -->
         </ast>
         <ast id="0" type="CS_INNER_CLASSES" text="" />
      </ast>
   </ast-root>

   <!-- class definition for class which extends other class -->
   <ast-root name="class_def_ext" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_CLASS" text="${classname}">
         <annotation datatype="java.lang.String" key="access" value="${access}" />
         <annotation datatype="java.lang.String" key="extends" value="${extends}" />
         <annotation datatype="java.lang.String" key="pkgname" value="${pkgname}" />
         <ast id="0" type="CS_CONSTANTS" text="" />
         <ast id="0" type="CS_STATIC_VARS" text="" />
         <ast id="0" type="CS_STATIC_INITS" text="" />
         <ast id="0" type="CS_INSTANCE_VARS" text="" />
         <ast id="0" type="CS_CONSTRUCTORS" text="" />
         <ast id="0" type="CS_STATIC_METHODS" text="" />
         <ast id="0" type="CS_INSTANCE_METHODS" text="" />
         <ast id="0" type="CS_INNER_CLASSES" text="" />
      </ast>
   </ast-root>

   <!-- class definition for inner frame class -->
   <ast-root name="inner_frame_def" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_CLASS" text="${classname}">
         <annotation datatype="java.lang.String" key="access" value="public static" />
         <annotation datatype="java.lang.String" key="extends" value="WidgetList" />
         <ast id="0" type="CS_INSTANCE_VARS" text="" />
         <ast id="0" type="CS_STATIC_INITS" text="" >
            <ast id="0" type="BLOCK" text="block"/>
         </ast>
      </ast>
   </ast-root>
   
   <!-- interface definition -->
   <ast-root name="interface_def" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_INTERFACE" text="${classname}">
         <annotation datatype="java.lang.String" key="access" value="${access}" />
         <annotation datatype="java.lang.String" key="extends" value="${extends}" />
         <annotation datatype="java.lang.String" key="pkgname" value="${pkgname}" />
         <ast id="0" type="CS_CONSTANTS" text="" />
         <ast id="0" type="CS_STATIC_VARS" text="" />
         <ast id="0" type="CS_STATIC_INITS" text="" />
         <ast id="0" type="CS_INSTANCE_VARS" text="" />
         <ast id="0" type="CS_CONSTRUCTORS" text="" />
         <ast id="0" type="CS_STATIC_METHODS" text="" />
         <ast id="0" type="CS_INSTANCE_METHODS" text="" />
         <ast id="0" type="CS_INNER_CLASSES" text="" />
      </ast>
   </ast-root>
   
   <!-- generate a getQuery method body -->
   <ast-root name="gen_getQuery" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_DEF" text="getQuery">
         <annotation datatype="java.lang.String" key="access" value="public" />
         <annotation datatype="java.lang.String" key="rettype" value="P2JQuery" />
         <annotation datatype="java.lang.Boolean" key="static" value="false" />
         <ast id="0" type="BLOCK" text="block">
            <ast id="0" type="KW_RETURN" text="">
               <ast col="0" id="0" line="0" text="${query}" type="REFERENCE"/>
            </ast>
         </ast>
      </ast>
   </ast-root>

   <!-- generate a setUp method body -->
   <ast-root name="gen_setUp" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_DEF" text="setup">
         <annotation datatype="java.lang.String" key="access" value="public" />
         <annotation datatype="java.lang.String" key="rettype" value="void" />
         <annotation datatype="java.lang.Boolean" key="static" value="false" />
         <ast id="0" type="LPARENS" text="">
           <ast id="0" type="REFERENCE_DEF" text="CommonFrame">
             <annotation datatype="java.lang.String" key="name" value="frame" />
           </ast>
         </ast>
         <ast id="0" type="BLOCK" text="block"/>
      </ast>
   </ast-root>   
   
   <!-- runnable inner class definition -->
   <ast-root name="runnable_inner_class_def"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_CLASS" text="${classname}">
         <annotation datatype="java.lang.String" key="access" value="private" />
         <ast id="0" type="KW_IMPLEMENTS" text="">
            <ast id="0" type="CLASS_REFERENCE" text="Runnable" />
         </ast>
         <ast id="0" type="CS_INSTANCE_VARS" text="" />
         <ast id="0" type="CS_INSTANCE_METHODS" text="">
            <ast id="0" type="METHOD_DEF" text="run">
               <annotation datatype="java.lang.String" key="access" value="public" />
               <annotation datatype="java.lang.String" key="rettype" value="void" />
               <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- trigger inner class definition -->
   <ast-root name="trigger_inner_class_def"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_CLASS" text="${classname}">
         <annotation datatype="java.lang.String" key="access" value="public" />
         <annotation datatype="java.lang.String" key="extends" value="Trigger" />
         <ast id="0" type="BLOCK" text="block"/>
         <ast id="0" type="CS_INSTANCE_VARS" text="" />
         <ast id="0" type="CS_INSTANCE_METHODS" text="">
            <ast id="0" type="METHOD_DEF" text="init">
               <annotation datatype="java.lang.String" key="access" value="public" />
               <annotation datatype="java.lang.String" key="rettype" value="void" />
               <ast id="0" type="BLOCK" text="block" />
            </ast>
            <ast id="0" type="METHOD_DEF" text="body">
               <annotation datatype="java.lang.String" key="access" value="public" />
               <annotation datatype="java.lang.String" key="rettype" value="void" />
               <ast id="0" type="BLOCK" text="block">
                  <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
               </ast>
            </ast>
         </ast>
      </ast>
   </ast-root>

   <!-- database session inner class definition for trigger events -->
   <ast-root name="database_trigger_inner_class_def"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst">
      <ast id="0" type="KW_CLASS" text="${classname}">
         <annotation datatype="java.lang.String" key="access" value="public"/>
         <annotation datatype="java.lang.String" key="extends"
                     value="DatabaseTrigger&lt;${bufclass}&gt;"/>
         <ast id="0" type="CS_INSTANCE_VARS" text=""/>
         <ast id="0" text="Override" type="ANNOTATION" />
         <ast id="0" type="METHOD_DEF" text="${funcname}">
            <annotation datatype="java.lang.String" key="access" value="public"/>
            <annotation datatype="java.lang.String" key="rettype" value="void"/>
            <ast id="0" type="LPARENS" text=""/>
            <ast id="0" type="BLOCK" text="block">
               <ast id="0" type="STATIC_METHOD_CALL" text="trigger">
                  <ast id="0" type="ANON_CTOR" text="Block">
                     <ast id="0" type="BLOCK" text="block" />
                     <ast id="0" type="CS_INSTANCE_METHODS" text="">
                        <ast id="0" type="METHOD_DEF" text="init">
                           <annotation datatype="java.lang.String" key="access" value="public"/>
                           <annotation datatype="java.lang.String" key="rettype" value="void"/>
                           <ast id="0" type="BLOCK" text="block"/>
                        </ast>
                        <ast id="0" type="METHOD_DEF" text="body">
                           <annotation datatype="java.lang.String" key="access" value="public"/>
                           <annotation datatype="java.lang.String" key="rettype" value="void"/>
                           <ast id="0" type="BLOCK" text="block">
                              <annotation datatype="java.lang.Boolean" key="peernode" value="true"/>
                           </ast>
                        </ast>
                     </ast>
                  </ast>
               </ast>
             </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- validatable inner class definition -->
   <ast-root name="validatable_inner_class_def"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_CLASS" text="${classname}">
         <annotation datatype="java.lang.String" key="access" value="private" />
         <annotation datatype="java.lang.String" key="extends" value="Validator" />
         <ast id="0" type="CS_INSTANCE_METHODS" text="">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
            <ast id="0" type="METHOD_DEF" text="validateExpression">
               <annotation datatype="java.lang.String" key="access" value="public" />
               <annotation datatype="java.lang.String" key="rettype" value="logical" />
               <ast id="0" type="LPARENS" text="">
                 <ast id="0" type="REFERENCE_DEF" text="BaseDataType">
                   <annotation datatype="java.lang.String" key="name" value="_newValue_" />
                 </ast>
               </ast>
               <ast id="0" type="BLOCK" text="block">
                  <ast id="0" type="ASSIGN" text="=">
                     <ast id="0" type="REFERENCE_DEF" text="${wrapper}">
                        <annotation datatype="java.lang.Boolean" key="final" value="true" />
                        <annotation datatype="java.lang.String" key="name" value="${javaname}" />
                     </ast>
                     <ast id="0" type="CAST" text="${wrapper}">
                        <ast id="0" type="REFERENCE" text="_newValue_" />
                     </ast>
                  </ast>
                  <ast id="0" type="KW_RETURN" text="" />
               </ast>
            </ast>
            <ast id="0" type="METHOD_DEF" text="validateMessage">
               <annotation datatype="java.lang.String" key="access" value="public" />
               <annotation datatype="java.lang.String" key="rettype" value="character" />
               <ast id="0" type="LPARENS" text="">
                 <ast id="0" type="REFERENCE_DEF" text="BaseDataType">
                   <annotation datatype="java.lang.String" key="name" value="_newValue_" />
                 </ast>
               </ast>
               <ast id="0" type="BLOCK" text="block">
                  <ast id="0" type="ASSIGN" text="=">
                     <ast id="0" type="REFERENCE_DEF" text="${wrapper}">
                        <annotation datatype="java.lang.Boolean" key="final" value="true" />
                        <annotation datatype="java.lang.String" key="name" value="${javaname}" />
                     </ast>
                     <ast id="0" type="CAST" text="${wrapper}">
                        <ast id="0" type="REFERENCE" text="_newValue_" />
                     </ast>
                  </ast>
                  <ast id="0" type="KW_RETURN" text="" />
               </ast>
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- BufferValidator inner class definition -->
   <ast-root name="buffer_validator_inner_class_def"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_CLASS" text="${classname}">
         <annotation datatype="java.lang.String" key="access" value="private" />
         <annotation datatype="java.lang.String" key="extends" value="BufferValidator" />
         <ast id="0" type="CS_INSTANCE_METHODS" text="">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
            <ast id="0" type="METHOD_DEF" text="validateExpression">
               <annotation datatype="java.lang.String" key="access" value="public" />
               <annotation datatype="java.lang.String" key="rettype" value="logical" />
               <ast id="0" type="BLOCK" text="block">
                  <ast id="0" type="KW_RETURN" text="" />
               </ast>
            </ast>
            <ast id="0" type="METHOD_DEF" text="validateMessage">
               <annotation datatype="java.lang.String" key="access" value="public" />
               <annotation datatype="java.lang.String" key="rettype" value="character" />
               <ast id="0" type="BLOCK" text="block">
                  <ast id="0" type="KW_RETURN" text="" />
               </ast>
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- embedded assignment inner class definition -->
   <ast-root name="embedded_assignment_inner_class_def"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_CLASS" text="${classname}">
         <annotation datatype="java.lang.String" key="access" value="private" />
         <annotation datatype="java.lang.String" key="extends" value="GenericExpression" />
         <ast id="0" type="CS_INSTANCE_METHODS" text="">
            <ast id="0" type="METHOD_DEF" text="resolve">
               <annotation datatype="java.lang.String" key="access" value="public" />
               <annotation datatype="java.lang.String" key="rettype" value="BaseDataType" />
               <ast id="0" type="BLOCK" text="block">
                  <ast id="0" type="KW_RETURN" text="">
                     <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
                  </ast>
               </ast>
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- block inner class definition -->
   <ast-root name="block_inner_class_def"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ANON_CTOR" text="Block">
         <!-- default c'tor block -->
         <ast id="0" type="BLOCK" text="block" />
         
         <ast id="0" type="CS_INSTANCE_VARS" text="" />
         <ast id="0" type="CS_INSTANCE_METHODS" text="">
            <ast id="0" type="METHOD_DEF" text="init">
               <annotation datatype="java.lang.String" key="access" value="public" />
               <annotation datatype="java.lang.String" key="rettype" value="void" />
               <ast id="0" type="BLOCK" text="block" />
            </ast>
            <ast id="0" type="METHOD_DEF" text="body">
               <annotation datatype="java.lang.String" key="access" value="public" />
               <annotation datatype="java.lang.String" key="rettype" value="void" />
               <ast id="0" type="BLOCK" text="block">
                  <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
               </ast>
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- enter method to be added to a block inner class definition -->
   <ast-root name="enter_method_def"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_DEF" text="enter">
         <annotation datatype="java.lang.String" key="access" value="public" />
         <annotation datatype="java.lang.String" key="rettype" value="void" />
         <ast id="0" type="BLOCK" text="block">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- assignment operator on a previously initialized variable using a one
        argument constructor -->
   <ast-root name="variable_assign_op" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="">
         <ast id="0" type="REFERENCE" text="${javaname}" />
         <ast id="0" type="CONSTRUCTOR" text="${wrapper}">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
            <ast id="0" type="${type}" text="${text}" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- unfinished assignment operator -->
   <ast-root name="variable_assign_op_unfinished"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         <ast id="0" type="REFERENCE" text="${javaname}" />
      </ast>
   </ast-root>

   <!-- assignment operator on a previously initialized variable using a
        default constructor -->
   <ast-root name="variable_assign_op_default" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="">
         <ast id="0" type="REFERENCE" text="${javaname}" />
         <ast id="0" type="CONSTRUCTOR" text="${wrapper}" />
      </ast>
   </ast-root>
   
   <!-- assign method call on a previously initialized variable using a one
        argument constructor -->
   <ast-root name="variable_assign" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="assign">
         <ast id="0" type="REFERENCE" text="${javaname}" />
         <ast id="0" type="CONSTRUCTOR" text="${wrapper}">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
            <ast id="0" type="${type}" text="${text}" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- assign method call on a previously initialized variable using a
        default constructor -->
   <ast-root name="variable_assign_default" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="assign">
         <ast id="0" type="REFERENCE" text="${javaname}" />
         <ast id="0" type="CONSTRUCTOR" text="${wrapper}" />
      </ast>
   </ast-root>
   
   <!-- assign method call on a previously initialized variable;  caller
        defines value to be assigned -->
   <ast-root name="unfinished_variable_assign" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="assign">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         <ast id="0" type="REFERENCE" text="${javaname}" />
      </ast>
   </ast-root>
   
   <!-- assign method call on a previously initialized variable;  caller
        defines value to be assigned -->
   <ast-root name="unfinished_variable_call_assign" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="assign">
         <ast id="0" type="REFERENCE" text="${javaname}" />
         <ast id="0" type="STATIC_METHOD_CALL" text="${method_txt}">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- assign operation on a previously initialized variable using an
        unfinished constructor -->
   <ast-root name="variable_assign_unfin_ctor_op" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="">
         <ast id="0" type="REFERENCE" text="${javaname}" />
         <ast id="0" type="CONSTRUCTOR" text="${wrapper}">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- assign method call on a previously initialized variable using an
        unfinished constructor -->
   <ast-root name="variable_assign_unfin_ctor" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="assign">
         <ast id="0" type="REFERENCE" text="${javaname}" />
         <ast id="0" type="CONSTRUCTOR" text="${wrapper}">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- array var assignment to an element of a new array -->
   <ast-root name="array_variable_assign"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         <ast id="0" type="REFERENCE" text="${javaname}">
            <ast id="0" type="LBRACKET" text="[">
               <ast id="0" type="NUM_LITERAL" text="${index}" />
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- array var assignment to an element of a new array using an unfinished
        constructor -->
   <ast-root name="array_variable_assign_unfin_ctor"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE" text="${javaname}">
            <ast id="0" type="LBRACKET" text="[">
               <ast id="0" type="NUM_LITERAL" text="${index}" />
            </ast>
         </ast>
         <ast id="0" type="CONSTRUCTOR" text="${wrapper}">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- define a final variable -->
   <ast-root name="variable_def_final" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${wrapper}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
            <annotation datatype="java.lang.Boolean" key="final" value="${final}" />
         </ast>
         <ast id="0" type="CONSTRUCTOR" text="${wrapper}">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
            <ast id="0" type="${type}" text="${text}" />
         </ast>
      </ast>
   </ast-root>

   <!-- define a variable -->
   <ast-root name="variable_def" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${wrapper}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="CONSTRUCTOR" text="${wrapper}">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
            <ast id="0" type="${type}" text="${text}" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- define a variable -->
   <ast-root name="variable_def_no_parm" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${wrapper}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="CONSTRUCTOR" text="${wrapper}">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- instantiate a variable using a default constructor -->
   <ast-root name="variable_def_default" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${wrapper}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="CONSTRUCTOR" text="${wrapper}" />
      </ast>
   </ast-root>
   
   <!-- instantiate a final variable using a default constructor -->
   <ast-root name="variable_def_default_final" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${wrapper}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
            <annotation datatype="java.lang.Boolean" key="final" value="${final}" />
         </ast>
         <ast id="0" type="CONSTRUCTOR" text="${wrapper}" />
      </ast>
   </ast-root>

   <!-- instantiate a final variable using a 1 param constructor -->
   <ast-root name="variable_def_final_1_param" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${wrapper}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
            <annotation datatype="java.lang.Boolean" key="final" value="${final}" />
         </ast>
         <ast id="0" type="CONSTRUCTOR" text="${wrapper}">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
            <ast id="0" type="${type}" text="${text}" />
         </ast>
      </ast>
   </ast-root>

   <!-- instantiate a final variable using a 2 param constructor -->
   <ast-root name="variable_def_final_2_param" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${wrapper}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
            <annotation datatype="java.lang.Boolean" key="final" value="${final}" />
         </ast>
         <ast id="0" type="CONSTRUCTOR" text="${wrapper}">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
            <ast id="0" type="${type1}" text="${text1}" />
            <ast id="0" type="${type2}" text="${text2}" />
         </ast>
      </ast>
   </ast-root>

   <!-- instantiate a variable using a default constructor for another class -->
   <ast-root name="variable_def_default_other" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${wrapper}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="CONSTRUCTOR" text="${other}">
            <ast id="0" type="STRING" text="${pname}" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- instantiate a variable using an unfinished constructor -->
   <ast-root name="variable_def_unfin_ctor" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${wrapper}">
            <annotation datatype="java.lang.Boolean" key="final" value="${final}" />
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="CONSTRUCTOR" text="${wrapper}">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- instantiate a variable assigned to null -->
   <ast-root name="variable_def_null" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${wrapper}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="NULL_LITERAL" text="null" />
      </ast>
   </ast-root>
   
   <!-- variable defined as an anonymous inner subclass of a resolvable
        expression class -->
   <ast-root name="variable_def_anon_expr" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${wrapper}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="ANON_CTOR" text="${wrapper}">
            <ast id="0" type="CS_INSTANCE_METHODS" text="">
               <ast id="0" type="METHOD_DEF" text="execute">
                  <annotation datatype="java.lang.String" key="access" value="public" />
                  <annotation datatype="java.lang.String" key="rettype" value="${rettype}" />
                  <ast id="0" type="BLOCK" text="block">
                     <ast id="0" type="KW_RETURN" text="">
                        <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
                     </ast>
                  </ast>
               </ast>
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- inner subclass of an output extent parameter class - in case of variables set as parameter -->
   <ast-root name="output_extent_var_expr" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_CLASS" text="${classname}">
         <annotation datatype="java.lang.String" key="access" value="private" />
         <annotation datatype="java.lang.String" key="extends" value="${extentParamClass}&lt;${rettype}&gt;" />
         <ast id="0" type="CS_INSTANCE_METHODS" text="">
            <ast id="0" type="METHOD_DEF" text="getVariable">
               <annotation datatype="java.lang.String" key="access" value="public" />
               <annotation datatype="java.lang.String" key="rettype" value="${rettype}[]" />
               <ast id="0" type="BLOCK" text="block">
                  <ast id="0" type="KW_RETURN" text="">
                     <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
                  </ast>
               </ast>
            </ast>
            <ast id="0" type="METHOD_DEF" text="setVariable">
               <annotation datatype="java.lang.String" key="access" value="public" />
               <annotation datatype="java.lang.String" key="rettype" value="void" />
               <ast col="0" id="0" line="0" text="" type="LPARENS">
                  <ast col="0" id="0" line="0" text="${rettype}[]" type="REFERENCE_DEF">
                     <annotation datatype="java.lang.Boolean" key="final" value="true" />
                     <annotation datatype="java.lang.String" key="name" value="newRef" />
                  </ast>
               </ast>
               <ast id="0" type="BLOCK" text="block">
                  <ast id="0" type="ASSIGN" text="=">
                     <ast col="0" id="0" line="0" text="newRef" type="REFERENCE" />
                  </ast>
               </ast>
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- inner subclass of a resolvable expression class -->
   <ast-root name="anon_expr" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ANON_CTOR" text="${classname}">
         <ast id="0" type="CS_INSTANCE_METHODS" text="">
            <ast id="0" type="METHOD_DEF" text="${methname}">
               <annotation datatype="java.lang.String" key="access" value="public" />
               <annotation datatype="java.lang.String" key="rettype" value="${rettype}" />
               <ast id="0" type="BLOCK" text="block">
                  <ast id="0" type="KW_RETURN" text="">
                     <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
                  </ast>
               </ast>
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- variable defined as an anonymous inner subclass of a where clause
        expression class -->
   <ast-root name="variable_def_anon_where" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="WhereExpression">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="ANON_CTOR" text="WhereExpression">
            <ast id="0" type="CS_INSTANCE_METHODS" text="">
               <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- Custom WhereExpression getSubstitutions method implementation -->
   <ast-root name="where_get_subs_meth_def" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_DEF" text="getSubstitutions">
         <annotation datatype="java.lang.String" key="access" value="public" />
         <annotation datatype="java.lang.String" key="rettype" value="Object[]" />
         <ast id="0" type="BLOCK" text="block">
            <ast id="0" type="KW_RETURN" text="">
               <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- Custom WhereExpression evaluate method implementation -->
   <ast-root name="where_evaluate_meth_def" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_DEF" text="evaluate">
         <annotation datatype="java.lang.String" key="access" value="public" />
         <annotation datatype="java.lang.String" key="rettype" value="logical" />
         <ast id="0" type="LPARENS" text="">
           <ast id="0" type="REFERENCE_DEF" text="BaseDataType[]">
             <annotation datatype="java.lang.Boolean" key="final" value="true" />
             <annotation datatype="java.lang.String" key="name" value="args" />
           </ast>
         </ast>
         <ast id="0" type="BLOCK" text="block">
            <ast id="0" type="KW_RETURN" text="">
               <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- register a global variable for undo support -->
   <ast-root name="register_undo_global"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.registerUndo">
         <ast id="0" type="BOOL_TRUE" text="" />
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
      </ast>
   </ast-root>
   
   <!-- register an IN handle function -->
   <ast-root name="register_in_handle_function"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="ProcedureManager.registerFunctionHandle">
         <ast id="0" type="STRING" text="${functionName}" />
         <ast id="0" type="REFERENCE" text="${handleExpr}" />
      </ast>
   </ast-root>
   
   <!-- register an array of global variables for undo support -->
   <ast-root name="register_undo_global_var_args"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.registerGlobal">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
      </ast>
   </ast-root>
   
   <!-- de-register an object for undo -->
   <ast-root name="deregister"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.deregister">
         <ast id="0" type="EXPRESSION" text="">
            <ast id="0" type="REFERENCE_DEF" text="new Undoable[]">
            </ast>
            <ast id="0" type="INITIALIZER" text="">
               <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- de-register an extent object for undo -->
   <ast-root name="deregister_extent"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.deregister">
         <ast id="0" type="EXPRESSION" text="">
            <ast id="0" type="REFERENCE_DEF" text="new Undoable[][]">
            </ast>
            <ast id="0" type="INITIALIZER" text="">
               <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- register an object for cleanup processing -->
   <ast-root name="register_finish"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.register${type}Finalizable">
         <ast id="0" type="REFERENCE" text="${javaname}" />
         <ast id="0" type="${bool_val}" text="" />
      </ast>
   </ast-root>
   
   <!-- instantiate a variable that is assigned null -->
   <ast-root name="variable_def_null" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${wrapper}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="NULL_LITERAL" text="null" />
      </ast>
   </ast-root>
   
   <!-- instantiate a variable that is assigned from a copy of another
        variable of the same or compatible type -->
   <ast-root name="variable_def_from_copy" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${classname}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="CONSTRUCTOR" text="${classname}">
            <ast id="0" type="REFERENCE" text="${src_javaname}" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- instantiate a memptr parameter as a new field -->
   <ast-root name="memptr_parameter_inst_var" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="memptr">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="STATIC_METHOD_CALL" text="memptr.${param_type}Parameter">
            <ast id="0" type="REFERENCE" text="${src_javaname}" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- instantiate a memptr parameter -->
   <ast-root name="memptr_parameter" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="memptr.${param_type}Parameter">
         <ast id="0" type="REFERENCE" text="${src_javaname}" />
      </ast>
   </ast-root>

   <!-- instantiate a variable that is assigned from a copy of another
        variable of the same or compatible type -->
   <ast-root name="variable_def_from_copy_ext" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${classname}[]">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="STATIC_METHOD_CALL" text="ArrayAssigner.copyOf">
            <ast id="0" type="REFERENCE" text="${src_javaname}" />
         </ast>
      </ast>
   </ast-root>

   <!-- instantiate an input table-handle parameter -->
   <ast-root name="tab_hand_def_input" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${classname}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="CONSTRUCTOR" text="${classname}">
            <ast id="0" type="METHOD_CALL" text="getTableHandle">
               <ast id="0" type="REFERENCE" text="${src_javaname}" />
            </ast>
         </ast>
      </ast>
   </ast-root>

   <!-- instantiate an output or input-output table-handle parameter -->
   <ast-root name="tab_hand_def" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${classname}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="METHOD_CALL" text="getTableHandle">
            <ast id="0" type="REFERENCE" text="${src_javaname}" />
         </ast>
      </ast>
   </ast-root>

   <!-- get handle from input TableParameter  -->
   <ast-root name="tab_hand_def_right_input" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="CONSTRUCTOR" text="${classname}">
         <ast id="0" type="METHOD_CALL" text="getTableHandle">
            <ast id="0" type="REFERENCE" text="${src_javaname}" />
         </ast>
      </ast>
   </ast-root>

   <!-- get handle from input-output or output TableParameter -->
   <ast-root name="tab_hand_def_right" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="getTableHandle">
         <ast id="0" type="REFERENCE" text="${src_javaname}" />
      </ast>
   </ast-root>

   <!-- assign table handle to a variable -->
   <ast-root name="tab_hand_assign" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="assign">
         <ast id="0" type="REFERENCE" text="${javaname1}"/>
         <ast id="0" type="METHOD_CALL" text="getTableHandle">
            <ast id="0" type="REFERENCE" text="${javaname2}" />
         </ast>
      </ast>
   </ast-root>

   <!-- instantiate a TableParameter -->
   <ast-root name="table_param" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="CONSTRUCTOR" text="TableParameter">
         <ast id="0" type="REFERENCE" text="${javaname}" />
      </ast>
   </ast-root>

   <!-- instantiate a TableParameter with append option -->
   <ast-root name="table_param_append" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="CONSTRUCTOR" text="TableParameter">
         <ast id="0" type="REFERENCE" text="${javaname}" />
         <ast id="0" type="BOOL_TRUE" text="true" />
      </ast>
   </ast-root>
   
   <!-- construct a regular record buffer -->
   <ast-root name="construct_buffer"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         <ast id="0" type="REFERENCE_DEF" text="${classname}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="STATIC_METHOD_CALL" text="RecordBuffer.define">
            <ast id="0" type="REFERENCE" text="${classname}.class" />
            <ast id="0" type="STRING" text="${dbname}" />
            <ast id="0" type="STRING" text="${javaname}" />
            <ast id="0" type="STRING" text="${legacybufname}" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- construct a regular record buffer initialized to null-->
   <ast-root name="construct_buffer_null"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${classname}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="NULL_LITERAL" text="null" />
      </ast>
   </ast-root>
   
   <!-- initialize a regular record buffer -->
   <ast-root name="initialize_buffer"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         <ast id="0" type="REFERENCE" text="${javaname}" />
         <ast id="0" type="STATIC_METHOD_CALL" text="RecordBuffer.define">
            <ast id="0" type="REFERENCE" text="${classname}.class" />
            <ast id="0" type="STRING" text="${dbname}" />
            <ast id="0" type="STRING" text="${javaname}" />
            <ast id="0" type="STRING" text="${legacybufname}" />
         </ast>
      </ast>
   </ast-root>

   <!-- variable definition to use a previously established, shared temp-table -->
   <ast-root name="var_def_shared_tt" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         <ast id="0" type="REFERENCE_DEF" text="${classname}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="CAST" text="${classname}">
            <ast id="0" type="STATIC_METHOD_CALL" text="TemporaryBuffer.useShared">
               <ast id="0" type="STRING" text="${javaname}" />
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- construct a temporary table master record buffer -->
   <ast-root name="construct_temp_master_buffer"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         <ast id="0" type="REFERENCE_DEF" text="${classname}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
      
         <ast id="0" type="STATIC_METHOD_CALL" text="TemporaryBuffer.define">
            <ast id="0" type="REFERENCE" text="${classname}.class" />
            <ast id="0" type="STRING" text="${javaname}" />
            <ast id="0" type="STRING" text="${legacybufname}" />
            <ast id="0" type="${global}" text="" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- construct a temporary table master record buffer, not undoable -->
   <ast-root name="construct_temp_master_buffer_no_undo"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         <ast id="0" type="REFERENCE_DEF" text="${classname}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="STATIC_METHOD_CALL" text="TemporaryBuffer.define">
            <ast id="0" type="REFERENCE" text="${classname}.class" />
            <ast id="0" type="STRING" text="${javaname}" />
            <ast id="0" type="STRING" text="${legacybufname}" />
            <ast id="0" type="${global}" text="" />
            <ast id="0" type="BOOL_FALSE" text="" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- construct a temporary table slave record buffer -->
   <ast-root name="construct_temp_slave_buffer"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         <ast id="0" type="REFERENCE_DEF" text="${classname}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="STATIC_METHOD_CALL" text="TemporaryBuffer.define">
            <ast id="0" type="REFERENCE" text="${master}" />
            <ast id="0" type="STRING" text="${javaname}" />
            <ast id="0" type="STRING" text="${legacybufname}" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- construct a temporary table slave record buffer initialized to null -->
   <ast-root name="construct_temp_slave_buffer_null"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${classname}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="NULL_LITERAL" text="null" />
      </ast>
   </ast-root>
   
   <!-- initialize a temporary table slave record buffer -->
   <ast-root name="initialize_temp_slave_buffer"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         <ast id="0" type="REFERENCE" text="${javaname}" />
         <ast id="0" type="STATIC_METHOD_CALL" text="TemporaryBuffer.define">
            <ast id="0" type="REFERENCE" text="${master}" />
            <ast id="0" type="STRING" text="${javaname}" />
            <ast id="0" type="STRING" text="${legacybufname}" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- factory for creating an unknown value of a specific type -->
   <ast-root name="gen_unknown"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="CAST" text="${wrapper}">
         <ast id="0" type="STATIC_METHOD_CALL" text="BaseDataType.generateUnknown">
            <ast id="0" type="REFERENCE" text="${wrapper}.class" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- construct a frame -->
   <ast-root name="construct_frame"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="GenericFrame.${methodname}">
         <ast id="0" type="REFERENCE" text="${classname}.class" />
         <ast id="0" type="STRING" text="${javaname}" />
      </ast>
   </ast-root>
   
   <!-- simple var definition allowing caller to complete assignment -->
   <ast-root name="unfinished_var_def"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         <ast id="0" type="REFERENCE_DEF" text="${classname}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- define an initialized constant -->
   <ast-root name="init_constant" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         <ast id="0" type="REFERENCE_DEF" text="${wrapper}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
            <annotation datatype="java.lang.String" key="access" value="public static final" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- define an initialized constant with a stub for the initializer -->
   <ast-root name="init_constant_full" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         <ast id="0" type="REFERENCE_DEF" text="${wrapper}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
            <annotation datatype="java.lang.String" key="access" value="public static final" />
         </ast>
         <ast id="0" type="${type}" text="${text}" />
      </ast>
   </ast-root>
   
   <!-- define a var with a stub for the initializer -->
   <ast-root name="init_var_full" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${wrapper}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="${type}" text="${text}">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- define a var with a stub for the initializer -->
   <ast-root name="init_var_full_no_wrap" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE_DEF" text="${wrapper}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
      </ast>
   </ast-root>
   
   <!-- test if a variable is null, then (no else) -->
   <ast-root name="if_not_null_then" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_IF" text="if">
         <ast id="0" type="EXPRESSION" text="expression">
            <ast id="0" type="NOT_EQ" text="!=">
               <ast id="0" type="REFERENCE" text="${javaname}" />
               <ast id="0" type="NULL_LITERAL" text="null" />
            </ast>
         </ast>
         <ast id="0" type="THEN" text="">
            <ast id="0" type="BLOCK_DEF" text="">
               <ast id="0" type="BLOCK" text="block">
                  <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
               </ast>
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- test if an expression is false, then break (no else) -->
   <ast-root name="if_not_true_then_break"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_IF" text="if">
         <ast id="0" type="LOGICAL_NOT" text="">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         </ast>
         <ast id="0" type="THEN" text="">
            <ast id="0" type="BLOCK_DEF" text="">
               <ast id="0" type="BLOCK" text="block">
                  <ast id="0" type="KW_BREAK" text="">
                     <ast id="0" type="LABEL" text="${java_label}" />
                  </ast>
               </ast>
            </ast>
         </ast>
      </ast>
   </ast-root>
                     
   <!-- test if a deferred leave is pending and break the given labeled
        block if so -->
   <ast-root name="deferred_break"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="BOGUS" text="">
         <ast id="0" type="SKIP" text="" />
         <ast id="0" type="KW_IF" text="if">
            <ast id="0" type="STATIC_METHOD_CALL" text="deferredLeave">
               <ast id="0" type="STRING" text="${java_label}" />
            </ast>
            <ast id="0" type="THEN" text="">
               <ast id="0" type="INDENT_GRP" text="">
                  <ast id="0" type="KW_BREAK" text="">
                     <ast id="0" type="LABEL" text="${java_label}" />
                  </ast>
               </ast>
            </ast>
         </ast>
      </ast>
   </ast-root>
                     
   <!-- test if a deferred leave/next is pending and break/continue the given
        labeled looping block if so -->
   <ast-root name="deferred_break_continue"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="BOGUS" text="">
         <ast id="0" type="SKIP" text="" />
         <ast id="0" type="KW_IF" text="if">
            <ast id="0" type="STATIC_METHOD_CALL" text="deferredLeave">
               <ast id="0" type="STRING" text="${java_label}" />
            </ast>
            <ast id="0" type="THEN" text="">
               <ast id="0" type="INDENT_GRP" text="">
                  <ast id="0" type="KW_BREAK" text="">
                     <ast id="0" type="LABEL" text="${java_label}" />
                  </ast>
               </ast>
            </ast>
         </ast>
         <ast id="0" type="KW_IF" text="if">
            <ast id="0" type="STATIC_METHOD_CALL" text="deferredNext">
               <ast id="0" type="STRING" text="${java_label}" />
            </ast>
            <ast id="0" type="THEN" text="">
               <ast id="0" type="INDENT_GRP" text="">
                  <ast id="0" type="KW_CONTINUE" text="">
                     <ast id="0" type="LABEL" text="${java_label}" />
                  </ast>
               </ast>
            </ast>
         </ast>
      </ast>
   </ast-root>
                     
   <!-- infinite loop protection helper for NEXT -->
   <ast-root name="honor_next"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_IF" text="if">
         <ast id="0" type="LOGICAL_NOT" text="">
            <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.honorNext">
               <ast id="0" type="STRING" text="${java_label}" />
            </ast>
         </ast>
         <ast id="0" type="THEN" text="">
            <ast id="0" type="BLOCK_DEF" text="">
               <ast id="0" type="BLOCK" text="block">
                  <ast id="0" type="KW_BREAK" text="">
                     <ast id="0" type="LABEL" text="${java_label}" />
                  </ast>
               </ast>
            </ast>
         </ast>
      </ast>
   </ast-root>
                     
   <!-- System.exit(0) -->
   <ast-root name="system_exit" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="System.exit">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         <ast id="0" type="EXPRESSION" text="expression">
            <ast id="0" type="NUM_LITERAL" text="0" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- throw an exception -->
   <ast-root name="throw_exception" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_THROW" text="throw">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         <ast id="0" type="CONSTRUCTOR" text="${except}">
            <ast id="0" type="EXPRESSION" text="expression">
               <ast id="0" type="STRING" text="${errmsg}" />
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- an infinite loop -->
   <ast-root name="infinite_loop" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_WHILE" text="while">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         <ast id="0" type="EXPRESSION" text="expression">
            <ast id="0" type="BOOL_TRUE" text="true" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- an anonymous array initializer -->
   <ast-root name="anon_array" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="EXPRESSION" text="">
         <ast id="0" type="REFERENCE_DEF" text="new ${classname}">
            <annotation datatype="java.lang.Long" key="extent" value="${extent}" />
         </ast>
         <ast id="0" type="INITIALIZER" text="">
            <annotation datatype="java.lang.Long" key="extent" value="${extent}" />
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- a named array initializer -->
   <ast-root name="named_array" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="">
         <ast id="0" type="REFERENCE_DEF" text="${classname}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
            <annotation datatype="java.lang.Long" key="extent" value="${extent}" />
         </ast>
         <ast id="0" type="EXPRESSION" text="">
            <ast id="0" type="REFERENCE_DEF" text="new ${classname}">
               <annotation datatype="java.lang.Long" key="extent" value="${extent}" />
            </ast>
            <ast id="0" type="INITIALIZER" text="">
               <annotation datatype="java.lang.Long" key="extent" value="${extent}" />
               <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- a named array initializer without an explicit extent -->
   <ast-root name="named_dynamic_array" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="">
         <ast id="0" type="REFERENCE_DEF" text="${classname}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="EXPRESSION" text="">
            <ast id="0" type="REFERENCE_DEF" text="new ${classname}" />
            <ast id="0" type="INITIALIZER" text="">
               <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- simple method call -->
   <ast-root name="method_call" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="${methodtxt}">
         <ast id="0" type="REFERENCE" text="${javaname}" />
      </ast>
   </ast-root>
   
   <!-- simple peer method call -->
   <ast-root name="peer_method_call" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="${methodtxt}">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         <ast id="0" type="REFERENCE" text="${javaname}" />
      </ast>
   </ast-root>
   
   <!-- add break group to accumulator -->
   <ast-root name="add_break_group" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="addBreakGroup">
         <ast id="0" type="REFERENCE" text="${accumname}" />
         <ast id="0" type="REFERENCE" text="${breakname}" />
      </ast>
   </ast-root>
   
   <!-- add accumulator to query -->
   <ast-root name="add_accumulator" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="addAccumulator">
         <ast id="0" type="REFERENCE" text="${queryname}" />
         <ast id="0" type="REFERENCE" text="${accumname}" />
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
      </ast>
   </ast-root>
   
   <!-- add sort criterion to presort query -->
   <ast-root name="add_sort_criterion" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="addSortCriterion">
         <ast id="0" type="REFERENCE" text="${queryname}" />
         <ast id="0" type="REFERENCE" text="${sortexpr}" />
      </ast>
   </ast-root>
   
   <!-- set query component iteration type -->
   <ast-root name="set_iteration_type" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="setIterationType">
         <ast id="0" type="REFERENCE" text="${queryname}" />
         <ast id="0" type="MEMBER" text="${itertype}">
            <ast id="0" type="REFERENCE" text="QueryConstants" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- add client-side where expression to a preselect query -->
   <ast-root name="add_where_expression" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="addWhereExpression">
         <ast id="0" type="REFERENCE" text="${queryname}" />
         <ast id="0" type="REFERENCE" text="${whexpname}" />
      </ast>
   </ast-root>
   
   <!-- add widget to widget list -->
   <ast-root name="add_widget" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="addWidget">
         <ast id="0" type="STRING" text="${wname}" />
         <ast id="0" type="STRING" text="${pname}" />
         <ast id="0" type="REFERENCE" text="${javaname}" />
      </ast>
   </ast-root>

   <!-- add widget to header widget list -->
   <ast-root name="add_header_widget" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="addHeaderWidget">
         <ast id="0" type="STRING" text="${wname}" />
         <ast id="0" type="REFERENCE" text="${javaname}" />
      </ast>
   </ast-root>
   
   <!-- set widget attribute -->
   <ast-root name="set_widget_attribute" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="${attribute}">
         <ast id="0" type="REFERENCE" text="${instance}" />
         <ast id="0" type="${vartype}" text="${varvalue}" />
      </ast>
   </ast-root>
   
   <!-- set widget value -->
   <ast-root name="set_widget_value" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="${attribute}">
         <ast id="0" type="CAST" text="${ftype}">
            <ast id="0" type="REFERENCE" text="frame" />
         </ast>
         <ast id="0" type="CONSTRUCTOR" text="${basetype}" >
            <ast id="0" type="${vartype}" text="${varvalue}" />
         </ast>
      </ast>
   </ast-root>

   <!-- set widget unknown value -->
   <ast-root name="set_widget_unknown_value" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="${attribute}">
         <ast id="0" type="CAST" text="${ftype}">
            <ast id="0" type="REFERENCE" text="frame" />
         </ast>
         <ast id="0" type="CONSTRUCTOR" text="${basetype}" >
         </ast>
      </ast>
   </ast-root>
   
   <!-- set widget color -->
   <ast-root name="set_widget_color" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="${clrname}">
         <ast id="0" type="REFERENCE" text="${instance}" />
         <ast id="0" type="CONSTRUCTOR" text="ColorSpec" >
            <ast id="0" type="${jtype}" text="${jname}" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- initializer for set items (ComboBox, SelectionList, RadioSet -->
   <ast-root name="set_widget_items" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="setItems">
         <ast id="0" type="REFERENCE" text="${instance}" />
         <ast id="0" type="REFERENCE_DEF" text="new ControlSetItem">
            <annotation datatype="java.lang.Long" key="extent" value="${size}" />
            <ast id="0" type="INITIALIZER" text="">
               <annotation datatype="java.lang.Long" key="extent" value="${size}" />
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- initializer for one item -->
   <ast-root name="one_item_init"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="CONSTRUCTOR" text="ControlSetItem">
         <ast id="0" type="CONSTRUCTOR" text="${labtype}">
            <ast id="0" type="${lvartype}" text="${lvarvalue}" />
         </ast>
         <ast id="0" type="CONSTRUCTOR" text="${dattype}">
            <ast id="0" type="${ldattype}" text="${ldatvalue}" />
         </ast>
      </ast>
   </ast-root>   
   
   <!-- null cast to a specific type -->
   <ast-root name="specific_null" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="CAST" text="${classname}">
         <ast id="0" type="NULL_LITERAL" text="null" />
      </ast>
   </ast-root>
   
   <!-- reference cast to a specific type -->
   <ast-root name="specific_ref" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="CAST" text="${classname}">
         <ast id="0" type="REFERENCE" text="${javaname}" />
      </ast>
   </ast-root>
   
   <!-- cast method call return value to a specific type -->
   <ast-root name="specific_method_call" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="CAST" text="${classname}">
         <ast id="0" type="METHOD_CALL" text="${methodtxt}">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- wrapped empty string -->
   <ast-root name="empty_string" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="CONSTRUCTOR" text="character">
         <ast id="0" type="STRING" text="" />
      </ast>
   </ast-root>
   
   <!-- unwrap a wrapper value -->
   <ast-root name="unwrap" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="${method_txt}">
         <ast id="0" type="LPARENS" text="(">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- add/subtract a literal to a variable and then assign back -->
   <ast-root name="add_and_assign" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="assign">
         <ast id="0" type="REFERENCE" text="${javaname}" />
         <ast id="0" type="STATIC_METHOD_CALL" text="${operator}">
            <ast id="0" type="REFERENCE" text="${javaname}" />
            <ast id="0" type="NUM_LITERAL" text="${increment}" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- assign a reference to another reference -->
   <ast-root name="ref_to_ref" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE" text="${javaname1}" />
         <ast id="0" type="REFERENCE" text="${javaname2}" />
      </ast>
   </ast-root>

   <!-- assign a reference to another casted reference -->
   <ast-root name="ref_to_cast_ref" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE" text="${javaname1}" />
         <ast id="0" type="CAST" text="${cast_type}">
            <ast id="0" type="REFERENCE" text="${javaname2}" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- set up an association between two temp table instances -->
   <ast-root name="associate_temp_tables" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="TemporaryBuffer.associate">
         <ast id="0" type="REFERENCE" text="${javaname1}" />
         <ast id="0" type="REFERENCE" text="${javaname2}" />
         <ast id="0" type="${input}" text="" />
         <ast id="0" type="${output}" text="" />
      </ast>
   </ast-root>

   <!-- create dynamic temp table -->
   <ast-root name="create_dynamic_tt" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="TemporaryBuffer.createDynamicTable">
         <ast id="0" type="REFERENCE" text="${javaname1}" />
         <ast id="0" type="REFERENCE" text="${javaname2}" />
         <ast id="0" type="${input}" text="" />
         <ast id="0" type="${output}" text="" />
      </ast>
   </ast-root>

   <!-- create dynamic temp table with append -->
   <ast-root name="create_dynamic_tt_append" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="TemporaryBuffer.createDynamicTable">
         <ast id="0" type="REFERENCE" text="${javaname1}" />
         <ast id="0" type="REFERENCE" text="${javaname2}" />
         <ast id="0" type="${input}" text="" />
         <ast id="0" type="${output}" text="" />
         <ast id="0" type="${append}" text="" />
      </ast>
   </ast-root>
   
   <!-- set up an association between two temp table instances with append -->
   <ast-root name="associate_temp_tables_append" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="TemporaryBuffer.associate">
         <ast id="0" type="REFERENCE" text="${javaname1}" />
         <ast id="0" type="REFERENCE" text="${javaname2}" />
         <ast id="0" type="${input}" text="" />
         <ast id="0" type="${output}" text="" />
         <ast id="0" type="${append}" text="" />
      </ast>
   </ast-root>
   
   <!-- assign a reference from a copy of this instance -->
   <ast-root name="ref_from_copy" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE" text="${javaname}" />
         <ast id="0" type="CONSTRUCTOR" text="${classname}">
            <ast id="0" type="REFERENCE" text="${javaname}" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- assign a reference from a copy of this instance -->
   <ast-root name="ref_from_copy_alt" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE" text="${javaname}" />
         <ast id="0" type="CONSTRUCTOR" text="${classname}">
            <ast id="0" type="REFERENCE" text="${src_javaname}" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- assign a reference from a copy of this instance -->
   <ast-root name="ref_from_copy_alt_ext" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <ast id="0" type="REFERENCE" text="${javaname}" />
         <ast id="0" type="STATIC_METHOD_CALL" text="ArrayAssigner.copyOf">
            <ast id="0" type="REFERENCE" text="${src_javaname}" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- assign a reference from arbitrary content -->
   <ast-root name="simple_unfinished_assign" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         <ast id="0" type="REFERENCE" text="${javaname}" />
      </ast>
   </ast-root>
   
   <!-- assign a variable from a method call -->
   <ast-root name="assign_wrapper_by_method_result" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="assign">
         <ast id="0" type="REFERENCE" text="${javaname}" />
         <ast id="0" type="METHOD_CALL" text="${methodtxt}">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         </ast>
      </ast>
   </ast-root>
   
    <!-- add a try/finally w shared var mgr support -->
   <ast-root name="try_finally_block" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="BLOCK" text="block">
         <ast id="0" type="STATIC_METHOD_CALL" text="SharedVariableManager.addScope" />
         <ast id="0" type="KW_TRY" text="try">
            <ast id="0" type="BLOCK" text="block">
               <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
            </ast>
         </ast>
         <ast id="0" type="KW_FINALLY" text="finally">
            <ast id="0" type="BLOCK" text="block">
               <ast id="0" type="STATIC_METHOD_CALL" text="SharedVariableManager.deleteScope" />
            </ast>
         </ast>
      </ast>
   </ast-root>   

   <!-- enclose an IF statement within a try/finally, to notify the accumulator
        that the IF has started and ended -->
   <ast-root name="accum_try_finally_block" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="BOGUS" text="">
         <ast id="0" type="KW_TRY" text="try">
            <ast id="0" type="BLOCK" text="block" />
         </ast>
         <ast id="0" type="KW_FINALLY" text="finally">
            <ast id="0" type="BLOCK" text="block" />
         </ast>
      </ast>
   </ast-root>   
   
    <!-- a top-level block with transaction mgr support -->
   <ast-root name="top_level_block"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="BLOCK" text="">
         <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.pushScope">
            <ast id="0" type="STRING" text="${java_label}" />
            <ast id="0" type="REFERENCE" text="TransactionManager.${trans_level}" />
            <ast id="0" type="${external}" text="" />
            <ast id="0" type="BOOL_TRUE" text="" />
            <ast id="0" type="BOOL_FALSE" text="" />
            <ast id="0" type="BOOL_FALSE" text="" />
            <ast id="0" type="REFERENCE" text="BlockType.${block_type}" />
         </ast>
         <ast id="0" type="KW_TRY" text="try">
            <ast id="0" type="BLOCK" text="">
               <ast id="0" type="BLOCK_DEF" text="">
                  <ast id="0" type="LABEL_DEF" text="${java_label}" />
                  <ast id="0" type="BLOCK" text="block">
                     <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.blockSetup" />
                     <ast id="0" type="DO_WHILE" text="">
                        <ast id="0" type="BLOCK" text="">
                           <ast id="0" type="KW_TRY" text="try">
                              <ast id="0" type="BLOCK" text="">
                                 <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
                              </ast>
                           </ast>
                           <ast id="0" type="KW_CATCH" text="catch">
                              <ast id="0" type="REFERENCE_DEF" text="ErrorConditionException">
                                 <annotation datatype="java.lang.String" key="name" value="err_except" />
                              </ast>
                              <ast id="0" type="BLOCK" text="block">
                                 <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.honorError">
                                    <ast id="0" type="REFERENCE" text="err_except" />
                                 </ast>
                                 <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.rollback">
                                    <ast id="0" type="STRING" text="${java_label}" />
                                 </ast>
                                 <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.triggerRetry">
                                    <ast id="0" type="NULL_LITERAL" text="" />
                                 </ast>
                              </ast>
                           </ast>
                           <ast id="0" type="KW_CATCH" text="catch">
                              <ast id="0" type="REFERENCE_DEF" text="EndConditionException">
                                 <annotation datatype="java.lang.String" key="name" value="end_except" />
                              </ast>
                              <ast id="0" type="BLOCK" text="block">
                                 <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.rollback">
                                    <ast id="0" type="STRING" text="${java_label}" />
                                 </ast>
                                 <ast id="0" type="KW_BREAK" text="">
                                    <ast id="0" type="LABEL" text="${java_label}" />
                                 </ast>
                              </ast>
                           </ast>
                           <ast id="0" type="KW_CATCH" text="catch">
                              <ast id="0" type="REFERENCE_DEF" text="RetryUnwindException">
                                 <annotation datatype="java.lang.String" key="name" value="ru_except" />
                              </ast>
                              <ast id="0" type="BLOCK" text="block">
                                 <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.honorRetry">
                                    <ast id="0" type="REFERENCE" text="ru_except" />
                                 </ast>
                              </ast>
                           </ast>
                           <ast id="0" type="KW_CATCH" text="catch">
                              <ast id="0" type="REFERENCE_DEF" text="Throwable">
                                 <annotation datatype="java.lang.String" key="name" value="thr" />
                              </ast>
                              <ast id="0" type="BLOCK" text="block">
                                 <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.abnormalEnd">
                                    <ast id="0" type="REFERENCE" text="thr" />
                                 </ast>
                              </ast>
                           </ast>
                        </ast>
                        <ast id="0" type="EXPRESSION" text="">
                           <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.needsRetry" />
                        </ast>
                     </ast>
                  </ast>
               </ast>
            </ast>
         </ast>
         <ast id="0" type="KW_FINALLY" text="finally">
            <ast id="0" type="BLOCK" text="block">
               <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.popScope" />
            </ast>
         </ast>
      </ast>
   </ast-root>   
   
    <!-- a function block with transaction mgr support -->
   <ast-root name="function_block"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="BOGUS" text="">
         <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.pushScope">
            <ast id="0" type="STRING" text="${java_label}" />
            <ast id="0" type="REFERENCE" text="TransactionManager.${trans_level}" />
            <ast id="0" type="BOOL_FALSE" text="" />
            <ast id="0" type="BOOL_TRUE" text="" />
            <ast id="0" type="BOOL_FALSE" text="" />
            <ast id="0" type="BOOL_FALSE" text="" />
            <ast id="0" type="REFERENCE" text="BlockType.FUNCTION" />
         </ast>
         <ast id="0" type="KW_TRY" text="try">
            <ast id="0" type="BLOCK" text="">
               <ast id="0" type="BLOCK_DEF" text="">
                  <ast id="0" type="LABEL_DEF" text="${java_label}" />
                  <ast id="0" type="BLOCK" text="block">
                     <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.blockSetup" />
                     <ast id="0" type="DO_WHILE" text="">
                        <ast id="0" type="BLOCK" text="">
                           <ast id="0" type="KW_TRY" text="try">
                              <ast id="0" type="BLOCK" text="">
                                 <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
                              </ast>
                           </ast>
                           <ast id="0" type="KW_CATCH" text="catch">
                              <ast id="0" type="REFERENCE_DEF" text="ErrorConditionException">
                                 <annotation datatype="java.lang.String" key="name" value="err_except" />
                              </ast>
                              <ast id="0" type="BLOCK" text="block">
                                 <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.rollback">
                                    <ast id="0" type="STRING" text="${java_label}" />
                                 </ast>
                                 <ast id="0" type="KW_BREAK" text="">
                                    <ast id="0" type="LABEL" text="${java_label}" />
                                 </ast>
                              </ast>
                           </ast>
                           <ast id="0" type="KW_CATCH" text="catch">
                              <ast id="0" type="REFERENCE_DEF" text="EndConditionException">
                                 <annotation datatype="java.lang.String" key="name" value="end_except" />
                              </ast>
                              <ast id="0" type="BLOCK" text="block">
                                 <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.rollback">
                                    <ast id="0" type="STRING" text="${java_label}" />
                                 </ast>
                                 <ast id="0" type="KW_BREAK" text="">
                                    <ast id="0" type="LABEL" text="${java_label}" />
                                 </ast>
                              </ast>
                           </ast>
                           <ast id="0" type="KW_CATCH" text="catch">
                              <ast id="0" type="REFERENCE_DEF" text="RetryUnwindException">
                                 <annotation datatype="java.lang.String" key="name" value="ru_except" />
                              </ast>
                              <ast id="0" type="BLOCK" text="block">
                                 <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.honorRetry">
                                    <ast id="0" type="REFERENCE" text="ru_except" />
                                 </ast>
                              </ast>
                           </ast>
                           <ast id="0" type="KW_CATCH" text="catch">
                              <ast id="0" type="REFERENCE_DEF" text="Throwable">
                                 <annotation datatype="java.lang.String" key="name" value="thr" />
                              </ast>
                              <ast id="0" type="BLOCK" text="block">
                                 <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.abnormalEnd">
                                    <ast id="0" type="REFERENCE" text="thr" />
                                 </ast>
                              </ast>
                           </ast>
                        </ast>
                        <ast id="0" type="EXPRESSION" text="">
                           <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.needsRetry" />
                        </ast>
                     </ast>
                  </ast>
               </ast>
            </ast>
         </ast>
         <ast id="0" type="KW_FINALLY" text="finally">
            <ast id="0" type="BLOCK" text="block">
               <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.popScope" />
            </ast>
         </ast>
         <ast id="0" type="KW_RETURN" text="">
            <ast id="0" type="CAST" text="${return_type}">
               <ast id="0" type="STATIC_METHOD_CALL" text="BaseDataType.generateUnknown">
                  <ast id="0" type="REFERENCE" text="${return_type}.class" />
               </ast>
            </ast>
         </ast>
      </ast>
   </ast-root>   
   
    <!-- an inner_block with transaction mgr support -->
   <ast-root name="transaction_block"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="BOGUS" text="">
         <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.pushScope">
            <ast id="0" type="STRING" text="${java_label}" />
            <ast id="0" type="REFERENCE" text="TransactionManager.${trans_level}" />
            <ast id="0" type="BOOL_FALSE" text="" />
            <ast id="0" type="BOOL_FALSE" text="" />
            <ast id="0" type="${is_loop}" text="" />
            <ast id="0" type="${loop_next}" text="" />
            <ast id="0" type="REFERENCE" text="BlockType.${block_type}" />
         </ast>
         <ast id="0" type="KW_TRY" text="try">
            <ast id="0" type="BLOCK" text="">
               <ast id="0" type="BLOCK_DEF" text="">
                  <ast id="0" type="LABEL_DEF" text="${java_label}" />
                  <ast id="0" type="BLOCK" text="block">
                     <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.blockSetup" />
                     <ast id="0" type="DO_WHILE" text="">
                        <ast id="0" type="BLOCK" text="">
                           <ast id="0" type="KW_TRY" text="try">
                              <ast id="0" type="BLOCK" text="">
                                 <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
                              </ast>
                           </ast>
                           <ast id="0" type="KW_CATCH" text="catch">
                              <ast id="0" type="REFERENCE_DEF" text="RetryUnwindException">
                                 <annotation datatype="java.lang.String" key="name" value="ru_except" />
                              </ast>
                              <ast id="0" type="BLOCK" text="block">
                                 <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.honorRetry">
                                    <ast id="0" type="REFERENCE" text="ru_except" />
                                 </ast>
                              </ast>
                           </ast>
                           <ast id="0" type="KW_CATCH" text="catch">
                              <ast id="0" type="REFERENCE_DEF" text="Throwable">
                                 <annotation datatype="java.lang.String" key="name" value="thr" />
                              </ast>
                              <ast id="0" type="BLOCK" text="block">
                                 <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.abnormalEnd">
                                    <ast id="0" type="REFERENCE" text="thr" />
                                 </ast>
                              </ast>
                           </ast>
                        </ast>
                        <ast id="0" type="EXPRESSION" text="">
                           <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.needsRetry" />
                        </ast>
                     </ast>
                     <ast id="0" type="KW_IF" text="if">
                        <ast id="0" type="EXPRESSION" text="">
                           <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.isBreakPending" />
                        </ast>
                        <ast id="0" type="THEN" text="">
                           <ast id="0" type="BLOCK_DEF" text="">
                              <ast id="0" type="BLOCK" text="block">
                                 <ast id="0" type="KW_BREAK" text="">
                                    <ast id="0" type="LABEL" text="${java_label}" />
                                 </ast>
                              </ast>
                           </ast>
                        </ast>
                     </ast>
                  </ast>
               </ast>
            </ast>
         </ast>
         <ast id="0" type="KW_FINALLY" text="finally">
            <ast id="0" type="BLOCK" text="block">
               <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.popScope" />
            </ast>
         </ast>
      </ast>
   </ast-root>   
   
   <!-- an editing block with transaction mgr support -->
   <ast-root name="editing_block"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="BOGUS" text="">
         <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.pushScope">
            <ast id="0" type="STRING" text="${java_label}" />
            <ast id="0" type="REFERENCE" text="TransactionManager.SUB_TRANSACTION" />
            <ast id="0" type="BOOL_FALSE" text="" />
            <ast id="0" type="BOOL_FALSE" text="" />
            <ast id="0" type="BOOL_TRUE" text="" />
            <ast id="0" type="BOOL_TRUE" text="" />
            <ast id="0" type="REFERENCE" text="BlockType.EDITING" />
         </ast>
         <ast id="0" type="KW_TRY" text="try">
            <ast id="0" type="BLOCK" text="">
               <ast id="0" type="METHOD_CALL" text="startEditingMode">
                  <ast id="0" type="REFERENCE" text="${frame_name}" />
                  <ast id="0" type="REFERENCE" text="${widget_list}" />
                  <ast id="0" type="NUM_LITERAL" text="CommonFrame.${optype}" />
               </ast>            
               <ast id="0" type="BLOCK_DEF" text="">
                  <ast id="0" type="LABEL_DEF" text="${java_label}" />
                  <ast id="0" type="DO_WHILE" text="">
                     <ast id="0" type="BLOCK" text="block">
                        <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.blockSetup" />
                        <ast id="0" type="DO_WHILE" text="">
                           <ast id="0" type="BLOCK" text="">
                              <ast id="0" type="KW_TRY" text="try">
                                 <ast id="0" type="BLOCK" text="">
                                    <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
                                 </ast>
                              </ast>
                              <ast id="0" type="KW_CATCH" text="catch">
                                 <ast id="0" type="REFERENCE_DEF" text="ErrorConditionException">
                                    <annotation datatype="java.lang.String" key="name" value="err_except" />
                                 </ast>
                                 <ast id="0" type="BLOCK" text="block">
                                    <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.honorError">
                                       <ast id="0" type="REFERENCE" text="err_except" />
                                    </ast>
                                    <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.rollback">
                                       <ast id="0" type="STRING" text="${java_label}" />
                                    </ast>
                                    <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.triggerRetry">
                                       <ast id="0" type="NULL_LITERAL" text="" />
                                    </ast>
                                 </ast>
                              </ast>
                              <ast id="0" type="KW_CATCH" text="catch">
                                 <ast id="0" type="REFERENCE_DEF" text="RetryUnwindException">
                                    <annotation datatype="java.lang.String" key="name" value="ru_except" />
                                 </ast>
                                 <ast id="0" type="BLOCK" text="block">
                                    <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.honorRetry">
                                       <ast id="0" type="REFERENCE" text="ru_except" />
                                    </ast>
                                 </ast>
                              </ast>
                              <ast id="0" type="KW_CATCH" text="catch">
                                 <ast id="0" type="REFERENCE_DEF" text="Throwable">
                                    <annotation datatype="java.lang.String" key="name" value="thr" />
                                 </ast>
                                 <ast id="0" type="BLOCK" text="block">
                                    <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.abnormalEnd">
                                       <ast id="0" type="REFERENCE" text="thr" />
                                    </ast>
                                 </ast>
                              </ast>
                           </ast>
                           <ast id="0" type="EXPRESSION" text="">
                              <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.needsRetry" />
                           </ast>
                        </ast>
                        <ast id="0" type="KW_IF" text="if">
                           <ast id="0" type="EXPRESSION" text="">
                              <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.isBreakPending" />
                           </ast>
                           <ast id="0" type="THEN" text="">
                              <ast id="0" type="BLOCK_DEF" text="">
                                 <ast id="0" type="BLOCK" text="block">
                                    <ast id="0" type="KW_BREAK" text="">
                                       <ast id="0" type="LABEL" text="${java_label}" />
                                    </ast>
                                 </ast>
                              </ast>
                           </ast>
                        </ast>
                     </ast>
                     <ast id="0" type="EXPRESSION" text="">
                        <ast id="0" type="METHOD_CALL" text="continueEditing">
                           <ast id="0" type="REFERENCE" text="${frame_name}" />
                           <ast id="0" type="REFERENCE" text="${widget_list}" />
                        </ast>
                     </ast>
                  </ast>
               </ast>
            </ast>
         </ast>
         <ast id="0" type="KW_FINALLY" text="finally">
            <ast id="0" type="BLOCK" text="block">
               <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.popScope" />
            </ast>
         </ast>
      </ast>
   </ast-root>   
   
   <!-- an editing block with go-on and transaction mgr support -->
   <ast-root name="editing_block_go_on"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="BOGUS" text="">
         <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.pushScope">
            <ast id="0" type="STRING" text="${java_label}" />
            <ast id="0" type="REFERENCE" text="TransactionManager.SUB_TRANSACTION" />
            <ast id="0" type="BOOL_FALSE" text="" />
            <ast id="0" type="BOOL_FALSE" text="" />
            <ast id="0" type="BOOL_TRUE" text="" />
            <ast id="0" type="BOOL_TRUE" text="" />
            <ast id="0" type="REFERENCE" text="BlockType.EDITING" />
         </ast>
         <ast id="0" type="KW_TRY" text="try">
            <ast id="0" type="BLOCK" text="">
               <ast id="0" type="METHOD_CALL" text="startEditingMode">
                  <ast id="0" type="REFERENCE" text="${frame_name}" />
                  <ast id="0" type="REFERENCE" text="${widget_list}" />
                  <ast id="0" type="NUM_LITERAL" text="CommonFrame.${optype}" />
                  <ast id="0" type="REFERENCE" text="${wait_name}" />
               </ast>            
               <ast id="0" type="BLOCK_DEF" text="">
                  <ast id="0" type="LABEL_DEF" text="${java_label}" />
                  <ast id="0" type="DO_WHILE" text="">
                     <ast id="0" type="BLOCK" text="block">
                        <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.blockSetup" />
                        <ast id="0" type="DO_WHILE" text="">
                           <ast id="0" type="BLOCK" text="">
                              <ast id="0" type="KW_TRY" text="try">
                                 <ast id="0" type="BLOCK" text="">
                                    <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
                                 </ast>
                              </ast>
                              <ast id="0" type="KW_CATCH" text="catch">
                                 <ast id="0" type="REFERENCE_DEF" text="ErrorConditionException">
                                    <annotation datatype="java.lang.String" key="name" value="err_except" />
                                 </ast>
                                 <ast id="0" type="BLOCK" text="block">
                                    <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.honorError">
                                       <ast id="0" type="REFERENCE" text="err_except" />
                                    </ast>
                                    <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.rollback">
                                       <ast id="0" type="STRING" text="${java_label}" />
                                    </ast>
                                    <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.triggerRetry">
                                       <ast id="0" type="NULL_LITERAL" text="" />
                                    </ast>
                                 </ast>
                              </ast>
                              <ast id="0" type="KW_CATCH" text="catch">
                                 <ast id="0" type="REFERENCE_DEF" text="RetryUnwindException">
                                    <annotation datatype="java.lang.String" key="name" value="ru_except" />
                                 </ast>
                                 <ast id="0" type="BLOCK" text="block">
                                    <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.honorRetry">
                                       <ast id="0" type="REFERENCE" text="ru_except" />
                                    </ast>
                                 </ast>
                              </ast>
                              <ast id="0" type="KW_CATCH" text="catch">
                                 <ast id="0" type="REFERENCE_DEF" text="Throwable">
                                    <annotation datatype="java.lang.String" key="name" value="thr" />
                                 </ast>
                                 <ast id="0" type="BLOCK" text="block">
                                    <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.abnormalEnd">
                                       <ast id="0" type="REFERENCE" text="thr" />
                                    </ast>
                                 </ast>
                              </ast>
                           </ast>
                           <ast id="0" type="EXPRESSION" text="">
                              <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.needsRetry" />
                           </ast>
                        </ast>
                        <ast id="0" type="KW_IF" text="if">
                           <ast id="0" type="EXPRESSION" text="">
                              <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.isBreakPending" />
                           </ast>
                           <ast id="0" type="THEN" text="">
                              <ast id="0" type="BLOCK_DEF" text="">
                                 <ast id="0" type="BLOCK" text="block">
                                    <ast id="0" type="KW_BREAK" text="">
                                       <ast id="0" type="LABEL" text="${java_label}" />
                                    </ast>
                                 </ast>
                              </ast>
                           </ast>
                        </ast>
                     </ast>
                     <ast id="0" type="EXPRESSION" text="">
                        <ast id="0" type="METHOD_CALL" text="continueEditing">
                           <ast id="0" type="REFERENCE" text="${frame_name}" />
                           <ast id="0" type="REFERENCE" text="${widget_list}" />
                        </ast>
                     </ast>
                  </ast>
               </ast>
            </ast>
         </ast>
         <ast id="0" type="KW_FINALLY" text="finally">
            <ast id="0" type="BLOCK" text="block">
               <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.popScope" />
            </ast>
         </ast>
      </ast>
   </ast-root>   
   
   <!-- default ERROR processing -->
   <ast-root name="default_error_catch"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_CATCH" text="catch">
         <ast id="0" type="REFERENCE_DEF" text="ErrorConditionException">
            <annotation datatype="java.lang.String" key="name" value="err_except" />
         </ast>
         <ast id="0" type="BLOCK" text="block">
            <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.honorError">
               <ast id="0" type="REFERENCE" text="err_except" />
            </ast>
            <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.rollback">
               <ast id="0" type="STRING" text="${java_label}" />
            </ast>
            <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.triggerRetry">
               <ast id="0" type="NULL_LITERAL" text="" />
            </ast>
         </ast>
      </ast>
   </ast-root>      
   
   <!-- generic ERROR processing -->
   <ast-root name="error_catch"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_CATCH" text="catch">
         <ast id="0" type="REFERENCE_DEF" text="ErrorConditionException">
            <annotation datatype="java.lang.String" key="name" value="err_except" />
         </ast>
         <ast id="0" type="BLOCK" text="block">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
            <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.honorError">
               <ast id="0" type="REFERENCE" text="err_except" />
            </ast>
         </ast>
      </ast>
   </ast-root>      
   
   <!-- default ENDKEY processing -->
   <ast-root name="default_end_catch"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_CATCH" text="catch">
         <ast id="0" type="REFERENCE_DEF" text="EndConditionException">
            <annotation datatype="java.lang.String" key="name" value="end_except" />
         </ast>
         <ast id="0" type="BLOCK" text="block">
            <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.rollback">
               <ast id="0" type="STRING" text="${java_label}" />
            </ast>
            <ast id="0" type="KW_BREAK" text="">
               <ast id="0" type="LABEL" text="${java_label}" />
            </ast>
         </ast>
      </ast>
   </ast-root>   
   
   <!-- query off end processing -->
   <ast-root name="query_off_end_catch"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_CATCH" text="catch">
         <ast id="0" type="REFERENCE_DEF" text="QueryOffEndException">
            <annotation datatype="java.lang.String" key="name" value="qoe_except" />
         </ast>
         <ast id="0" type="BLOCK" text="block">
            <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.rollback">
               <ast id="0" type="STRING" text="${java_label}" />
            </ast>
            <ast id="0" type="KW_BREAK" text="">
               <ast id="0" type="LABEL" text="${java_label}" />
            </ast>
         </ast>
      </ast>
   </ast-root>   
   
   <!-- generic condition processing -->
   <ast-root name="other_condition_catch"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="KW_CATCH" text="catch">
         <ast id="0" type="REFERENCE_DEF" text="${up_ctype}ConditionException">
            <annotation datatype="java.lang.String" key="name" value="${ctype}_except" />
         </ast>
         <ast id="0" type="BLOCK" text="block">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         </ast>
      </ast>
   </ast-root>   
   
   <!-- add a variable/stream to the shared var mgr with no scope level
        parm -->
   <ast-root name="add_shared_var" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="SharedVariableManager.add${type}">
         <ast id="0" type="STRING" text="${sharename}" />
         <ast id="0" type="REFERENCE" text="${javaname}" />
      </ast>
   </ast-root>   
   
   <!-- add a variable/stream to the shared var mgr with a specific scope
        as the first parm -->
   <ast-root name="add_shared_var_scoped" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="SharedVariableManager.add${type}">
         <ast id="0" type="REFERENCE" text="${scope}" />
         <ast id="0" type="STRING" text="${sharename}" />
         <ast id="0" type="REFERENCE" text="${javaname}" />
      </ast>
   </ast-root>   
   
   <!-- add a variable to the shared var mgr and allow the caller to
        create the 2nd arg -->
   <ast-root name="inline_add_shared_var" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="SharedVariableManager.addVariable">
         <ast id="0" type="STRING" text="${sharename}" />
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
      </ast>
   </ast-root>   
   
   <!-- add a variable to the shared var mgr, create a scope level 1st parm
        and allow the caller to create the 3rd arg -->
   <ast-root name="inline_add_shared_var_scoped" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="SharedVariableManager.addVariable">
         <ast id="0" type="REFERENCE" text="${scope}" />
         <ast id="0" type="STRING" text="${sharename}" />
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
      </ast>
   </ast-root>   
   
   <!-- instantiate a variable that is assigned from var mgr -->
   <ast-root name="variable_def_import" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="ASSIGN" text="=">
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         <ast id="0" type="REFERENCE_DEF" text="${classname}">
            <annotation datatype="java.lang.String" key="name" value="${javaname}" />
         </ast>
         <ast id="0" type="STATIC_METHOD_CALL" text="SharedVariableManager.lookup${type}">
            <ast id="0" type="EXPRESSION" text="expression">
               <ast id="0" type="STRING" text="${javaname}" />
            </ast>
         </ast>
      </ast>
   </ast-root>
   
   <!-- lookup a variable/stream in the shared var mgr -->
   <ast-root name="lookup_shared_var" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="SharedVariableManager.lookup${type}">
         <ast id="0" type="EXPRESSION" text="expression">
            <ast id="0" type="STRING" text="${sharename}" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- generic subscripting -->
   <ast-root name="generic_subscript"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_CALL" text="subscript">
         <ast id="0" type="LPARENS" text="(">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- field subscripting in a where clause -->
   <ast-root name="dynamic_where_subscript"
             terse="true"
             ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="STATIC_METHOD_CALL" text="minus">
         <ast id="0" type="LPARENS" text="(">
            <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         </ast>
         <ast id="0" type="NUM_LITERAL" text="1" />
      </ast>
   </ast-root>
   
   <!-- standard method javadoc comment -->
   <ast-root name="javadoc_method" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="DOC_COMMENT" text="">
         <ast id="0" type="DOC_PARAGRAPH" text="">
            <annotation datatype="java.lang.Boolean" key="no-wrap" value="true" />
            <ast id="0" type="DOC_TEXTRUN" text="${content}" />
         </ast>
      </ast>
   </ast-root>
   
   <!-- add a standard main -->
   <ast-root name="main_method" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
      <ast id="0" type="METHOD_DEF" text="main">
         <annotation datatype="java.lang.String" key="access" value="public" />
         <annotation datatype="java.lang.String" key="rettype" value="void" />
         <annotation datatype="java.lang.Boolean" key="static" value="true" />
         <ast id="0" type="LPARENS" text="">
           <ast id="0" type="REFERENCE_DEF" text="String[]">
             <annotation datatype="java.lang.String" key="name" value="args" />
           </ast>
         </ast>
         <ast id="0" type="BLOCK" text="block">
            <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.pushScope">
               <ast id="0" type="STRING" text="startup" />
               <ast id="0" type="REFERENCE" text="TransactionManager.NO_TRANSACTION" />
               <ast id="0" type="BOOL_TRUE" text="" />
               <ast id="0" type="BOOL_TRUE" text="" />
               <ast id="0" type="BOOL_FALSE" text="" />
               <ast id="0" type="BOOL_FALSE" text="" />
            </ast>
            <ast id="0" type="KW_TRY" text="try">
               <ast id="0" type="BLOCK" text="">
                  <ast id="0" type="BLOCK_DEF" text="">
                     <ast id="0" type="LABEL_DEF" text="startup" />
                     <ast id="0" type="BLOCK" text="">
                        <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.blockSetup" />
                        <ast id="0" type="DO_WHILE" text="">
                           <ast id="0" type="BLOCK" text="">
                              <ast id="0" type="KW_TRY" text="try">
                                 <ast id="0" type="BLOCK" text="">
                                    <ast id="0" type="SLASH_COMMENT" text="reset the process base elapsed millis counter" />
                                    <ast id="0" type="STATIC_METHOD_CALL" text="date.elapsed">
                                       <ast id="0" type="BOOL_TRUE" text="true" />
                                    </ast>
                                    <ast id="0" type="ASSIGN" text="=">
                                       <ast id="0" type="REFERENCE_DEF" text="${classname}">
                                          <annotation datatype="java.lang.String" key="name" value="instance" />
                                       </ast>
                                       <ast id="0" type="CONSTRUCTOR" text="${classname}" />
                                    </ast>
                                    <ast id="0" type="METHOD_CALL" text="execute">
                                       <ast id="0" type="REFERENCE" text="instance" />
                                    </ast>                  
                                 </ast>
                              </ast>
                              <ast id="0" type="KW_CATCH" text="catch">
                                 <ast id="0" type="REFERENCE_DEF" text="StopConditionException">
                                    <annotation datatype="java.lang.String" key="name" value="stop_except" />
                                 </ast>
                                 <ast id="0" type="BLOCK" text="block">
                                    <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.triggerRetry">
                                       <ast id="0" type="NULL_LITERAL" text="" />
                                    </ast>
                                 </ast>
                              </ast>
                              <ast id="0" type="KW_CATCH" text="catch">
                                 <ast id="0" type="REFERENCE_DEF" text="ConditionException">
                                    <annotation datatype="java.lang.String" key="name" value="ce" />
                                 </ast>
                                 <ast id="0" type="BLOCK" text="block">
                                    <ast id="0" type="KW_BREAK" text="">
                                       <ast id="0" type="LABEL" text="startup" />
                                    </ast>
                                 </ast>
                              </ast>
                              <ast id="0" type="KW_CATCH" text="catch">
                                 <ast id="0" type="REFERENCE_DEF" text="RetryUnwindException">
                                    <annotation datatype="java.lang.String" key="name" value="ru_except" />
                                 </ast>
                                 <ast id="0" type="BLOCK" text="block">
                                    <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.honorRetry">
                                       <ast id="0" type="REFERENCE" text="ru_except" />
                                    </ast>
                                 </ast>
                              </ast>
                           </ast>
                           <ast id="0" type="EXPRESSION" text="">
                              <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.needsRetry" />
                           </ast>
                        </ast>
                        <ast id="0" type="KW_IF" text="if">
                           <ast id="0" type="EXPRESSION" text="">
                              <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.isBreakPending" />
                           </ast>
                           <ast id="0" type="THEN" text="">
                              <ast id="0" type="BLOCK_DEF" text="">
                                 <ast id="0" type="BLOCK" text="block">
                                    <ast id="0" type="KW_BREAK" text="">
                                       <ast id="0" type="LABEL" text="startup" />
                                    </ast>
                                 </ast>
                              </ast>
                           </ast>
                        </ast>
                     </ast>
                  </ast>
               </ast>
            </ast>
            <ast id="0" type="KW_CATCH" text="catch">
               <ast id="0" type="REFERENCE_DEF" text="Exception">
                  <annotation datatype="java.lang.String" key="name" value="exc" />
               </ast>
               <ast id="0" type="BLOCK" text="block">
                  <ast id="0" type="METHOD_CALL" text="printStackTrace">
                     <ast id="0" type="REFERENCE" text="exc" />
                  </ast>
               </ast>
            </ast>
            <ast id="0" type="KW_FINALLY" text="finally">
               <ast id="0" type="BLOCK" text="block">
                  <ast id="0" type="STATIC_METHOD_CALL" text="TransactionManager.popScope" />
               </ast>
            </ast>
         </ast>
      </ast>
   </ast-root>

   <!-- SchemaTriggerAssign annotation (buffer = <table>.Buf.class, overrideable = true,
      event = DatabaseEventType.<dbtype>, field = "<fieldname>", hasOldBuffer = false) -->
   <ast-root name="schema_trigger_annotation" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst">
      <ast id="0" type="ANNOTATION" text="SchemaTrigger">
         <ast id="0" type="ASSIGN" text="=">
            <ast id="0" type="REFERENCE" text="buffer" />
            <ast id="0" type="REFERENCE" text="${buffer_class}" />
         </ast>
         <ast id="0" type="ASSIGN" text="=">
            <ast id="0" type="REFERENCE" text="event" />
            <ast id="0" type="REFERENCE" text="${event_type}" />
         </ast>
         <ast id="0" type="ASSIGN" text="=">
            <ast id="0" type="REFERENCE" text="field" />
            <ast id="0" type="STRING" text="${field_name}" />
         </ast>
         <ast id="0" type="ASSIGN" text="=">
            <ast id="0" type="REFERENCE" text="overrideable" />
            <ast id="0" type="REFERENCE" text="${is_overrideable}" />
         </ast>
         <ast id="0" type="ASSIGN" text="=">
            <ast id="0" type="REFERENCE" text="hasOldBuffer" />
            <ast id="0" type="REFERENCE" text="${old_buffer}" />
         </ast>
      </ast>
   </ast-root>

</templates>
